//--------------------------------------------------------------
//  縦続形 IIR フィルタの構成要素として使う 2 次の IIR フィルタ
//      b0 は 1 と仮定している
//
//  2023/06/11, Copyright (c) 2023 MIKAMI, Naoki
//--------------------------------------------------------------

#include "mbed.h"

#ifndef IIR_BIQUAD_HPP
#define IIR_BIQUAD_HPP

class Biquad
{
public:
    // コンストラクタ
    Biquad(float a1=0, float a2=0, float b1=0, float b2=0)
        : a1_(a1), a2_(a2), b1_(b1), b2_(b2),
          vn1_(0), vn2_(0) {}

    // 2 次のフィルタを実行する
    float Execute(float xn)
    {
        float vn = xn + a1_*vn1_ + a2_*vn2_;
        float yn = vn + b1_*vn1_ + b2_*vn2_;

        vn2_ = vn1_;
        vn1_ = vn;

        return yn;
    }

private:
    float a1_, a2_, b1_, b2_;   // フィルタの係数
    float vn1_, vn2_;   // 単位遅延素子
};
#endif  // IIR_BIQUAD_HPP
