//--------------------------------------------------------------
//  Weaver 変調器を使う周波数シフタで使っているフィルタの係数
//
//  2023/08/21, Copyright (c) 2023 MIKAMI, Naoki
//--------------------------------------------------------------

#include "Biquad.hpp"

//--------------------------------------------------------------
// 入力帯域制限用帯域通過フィルタの係数
//--------------------------------------------------------------
// 帯域通過フィルタ
// 連立チェビシェフ特性
// 次数　　　　： 12 次
// 標本化周波数： 44.1000 kHz
// 遮断周波数１：  0.1000 kHz
// 遮断周波数２： 19.5000 kHz
// 通過域のリップル： 0.50 dB
// 阻止域の減衰量　：60.00 dB
const int ORDER_BPF_ = 12;    // 次数
const Biquad C_BP_[ORDER_BPF_/2] = {
    Biquad(-9.93330326E-01f, -3.51828586E-01f,  1.99368497E+00f, 1.0f),  // 1段目
    Biquad(-1.65777693E+00f, -8.27633228E-01f,  1.95992160E+00f, 1.0f),  // 2段目
    Biquad( 1.95713153E+00f, -9.58031794E-01f, -1.99999049E+00f, 1.0f),  // 3段目
    Biquad(-1.83783697E+00f, -9.63727325E-01f,  1.93549757E+00f, 1.0f),  // 4段目
    Biquad( 1.99206573E+00f, -9.92357806E-01f, -1.99993910E+00f, 1.0f),  // 5段目
    Biquad( 1.99832184E+00f, -9.98520935E-01f, -1.99990139E+00f, 1.0f)}; // 6段目
const float G0_BPF_ = 4.57477951E-01f;    // 利得定数

//--------------------------------------------------------------
// Weaver 変調器で使う低域通過フィルタの係数
//--------------------------------------------------------------
// 低域通過フィルタ
// 連立チェビシェフ特性
// 次数　　　　： 8 次
// 標本化周波数： 44.1000 kHz
// 遮断周波数  ：  9.7000 kHz
// 通過域のリップル： 0.50 dB
// 阻止域の減衰量　：60.00 dB
const int ORDER_LPF_ = 8;   // 次数
const Biquad C_LP_[ORDER_LPF_/2] = {
    Biquad( 1.08131464E+00f, -3.84262951E-01f,  1.68181466E+00f, 1.0f),  // 1段目
    Biquad( 7.26429747E-01f, -6.54070186E-01f,  5.58773116E-01f, 1.0f),  // 2段目
    Biquad( 4.63482084E-01f, -8.61277515E-01f,  3.52811978E-02f, 1.0f),  // 3段目
    Biquad( 3.62654043E-01f, -9.64865035E-01f, -1.28655898E-01f, 1.0f)}; // 4段目
const float G0_LPF_ = 1.65592156E-02f;    // 利得定数
